# /u/sy/beebe/misc/gutenberg/total.awk, Sat Apr 18 17:03:42 1992
# Edit by Nelson H. F. Beebe <beebe@magna.math.utah.edu>
# ========================================================================
# Output totals for population figures in state.raw.
# Usage:
#	awk -f total.awk state.raw >xxx
# [18-Apr-1992]
# ========================================================================
{
    total += strip_commas($2)
    white += strip_commas($3)
    black += strip_commas($5)
    indian += strip_commas($7)
    hispanic += strip_commas($9)
}
END   {
        printf("%-20s%12s%12s%5.1f%12s%5.1f%12s%5.1f%12s%5.1f\n",
	       "TOTAL",
	       add_commas(total),
	       add_commas(white), percent(white,total),
	       add_commas(black), percent(black,total),
	       add_commas(indian), percent(indian,total),
	       add_commas(hispanic), percent(hispanic,total))
}

function add_commas(s, k,digits,t,u)
{
    t = "" s			# convert to string
    u = ""
    digits = 0
    for (k = length(t); k > 0; --k)
    {
	digits++
        u = substr(t,k,1) u
	if (((digits % 3) == 0) && (k > 1))
	    u = "," u
    }
    return u
}

function percent(race,total)
{
    return (100.0 * strip_commas(race) / strip_commas(total))
}

function strip_commas(s, t)
{
    t = s
    gsub(/,/,"",t)
    return t
}
